# Chapter3.py

'''
Statements

control variable -> for keywords built in control, if keywords defined
condition -> conditional test to be applied to the control variable
expression -> do something if it meets the conditional test

variables, functions, methods, objects, class, services, providers, factories,...
3 questions to ask yourself to use an object
1. did I define it? -> you never declare it, if you don't plan to give it value.
2. did I give it value? -> assiging value to an object
3. did I return it? function-> yourself method-> something else
'''

# Controls
# if page 73
## if, elif <else if>, else
## break and continue are implicitly passed based on the conditional test
## we use == "in equality to" in Python to test value and type
### = "assign value to"  x = 7
### == "in equality to" -> tests value if x == 7 <type testing based on the value>
### === "strictly in equality to" tests type and value if x === 7, x must be an int and the value must be 7. We don't use this one in Python

x = 2 # control
# if (condition):
if x < 10:  # True or !True EAFP
    # expression<operation>
    print(x)
    # control variable is EXplicitly define
    x += 1
    print(x)
'''
else: # False  LBYP
    print("The number is 10 or greater")
'''

# for page 86
## for loop to output a range   for x in range() -> range() and len() EXplicit
## chapter 6 for loop to loop thru data for x in ys -> range() and len() IMplicit
## for in keywords

'''
Bob -> len(3) range(0<startIncluded>:3<stopExcluded>)  positionID(1<startIncluded>:3<stopIncluded)
['B','o','b'] List of chars
[0:3] -> step
(0, 3) -> parameters
'''
print("========")
# common for loops to loop thru data
# Python Syntax
numbers = [0,1,2,3,4,5,6,7,8] # len(9)
for x1 in range(0, len(numbers)): # range() control, condition
    print(x1) # x is the local variable in the scope
    # !increment control -> automatically
    # !condition -> ys
# Pythonic
for x1a in numbers: # for x in ys -> data set
    # data sets IMplicitly have range() and len() built it
    print(x1a) 

print("====")
for x2 in range(0, 10): # range() control, condition
    print(x2) # x is the local variable in the scope
    # !increment control -> automatically
    # !condition -> ys

# EOF