# Chapter1.py

'''
Comments and Documentation in Programming
# line comment
3 single quotes is a block comment
Chapter 4 will have more reason for using line and block comments
'''

'''
Best Practices for Naming Conventions in OOP
Application/Program TitleCase, !StartNumber, !spaces, under_score
Factory Container (Docker,Sharepoint,Redux,AWS S3...) TitleCase [a-zA-Z0-9]
PROVIDERS I/O's, API's, "provides data to a class" UPPERCASE
Services WebServices, MicroServices,IoT Services TitleCase, !Numbers, !spaces, !underscore
Classes Isolated Blocks of Code TitleCase -> Services
Class Objects -> functions -> Reusable Blocks of Code  joins/params, for loop
TitleCase, lowercase, camelCase, underscore_case (Normally not TitleCase)
Python ->
functions -> return value to themself range()
methods -> return value to something else
variables are assigned value in python 
value -> stdout(terminal) template variables, if statement
'''

'''
Principles for Programming in OOP
Law of Demeter -> https://en.wikipedia.org/wiki/Law_of_Demeter
DRY -> https://en.wikipedia.org/wiki/Don%27t_repeat_yourself
LBYL vs EAFP Principles -> if/else vs try/except 
https://en.wikipedia.org/wiki/EAFP
LBYL -> OOP -> Look Before You Leap
EAFP -> Python -> Easier to Ask for Forgivness than Permission 
Pythonic -> follows principles of programming related to resource allocation, framework, readability
'''

# EOF